using Learun.Application.TwoDevelopment.ZZDT_EC;
using Learun.Util;
using Learun.Util.Operat;
using System.Linq;
using System.Web.Mvc;

namespace Learun.Application.Web.Areas.ZZDT_EC.Controllers
{
    /// <summary>
    /// 版 本 PIT-ADMS V7.0.3 敏捷开发框架
    /// Copyright (c) 2013-2018 Hexagon PPM
    /// 创 建：超级管理员
    /// 日 期：2022-03-14 10:58
    /// 描 述：业务表
    /// </summary>
    public class ec_business_tableController : MvcControllerBase
    {
        private ec_business_tableIBLL ec_business_tableIBLL = new ec_business_tableBLL();

        #region 视图功能

        /// <summary>
        /// 主页面
        /// <summary>
        /// <returns></returns>
        [HttpGet]
        public ActionResult Index()
        {
             return View();
        }
        /// <summary>
        /// 表单页
        /// <summary>
        /// <returns></returns>
        [HttpGet]
        public ActionResult Form()
        {
             return View();
        }

        /// <summary>
        /// 选择页面
        /// <summary>
        /// <returns></returns>
        [HttpGet]
        public ActionResult SelectIndex()
        {
            return View();
        }
        #endregion

        #region 获取数据

        /// <summary>
        /// 获取列表数据
        /// <summary>
        /// <returns></returns>
        [HttpGet]
        [AjaxOnly]
        public ActionResult GetList(string queryJson)
        {
            var data = ec_business_tableIBLL.GetList(queryJson);
            return Success(data);
        }
        /// <summary>
        /// 获取列表分页数据
        /// <param name="pagination">分页参数</param>
        /// <summary>
        /// <returns></returns>
        [HttpGet]
        [AjaxOnly]
        public ActionResult GetPageList(string pagination, string queryJson)
        {
            Pagination paginationobj = pagination.ToObject<Pagination>();
            paginationobj.sidx = "BusinessTableCode";
            paginationobj.sord = "ASC";
            var data = ec_business_tableIBLL.GetList(queryJson, paginationobj);
            var jsonData = new
            {
                rows = data,
                total = paginationobj.total,
                page = paginationobj.page,
                records = paginationobj.records
            };
            return Success(jsonData);
        }
        /// <summary>
        /// 获取表单数据
        /// <param name="keyValue">主键</param>
        /// <summary>
        /// <returns></returns>
        [HttpGet]
        [AjaxOnly]
        public ActionResult GetFormData(string keyValue)
        {
            var data = ec_business_tableIBLL.GetEntity(keyValue);
            var jsonData = new
            {
                ec_business_table = data
            };
            return Success(jsonData);
        }
        #endregion

        #region 提交数据

        /// <summary>
        /// 删除实体数据
        /// <param name="keyValue">主键</param>
        /// <summary>
        /// <returns></returns>
        [HttpPost]
        [AjaxOnly]
        public ActionResult DeleteForm(string keyValue)
        {
            ec_business_tableIBLL.DeleteEntity(keyValue);
            return Success("删除成功！", "业务表管理", OperationType.Delete, null, null);
        }
        /// <summary>
        /// 保存实体数据（新增、修改）
        /// <param name="keyValue">主键</param>
        /// <summary>
        /// <returns></returns>
        [HttpPost]
        [ValidateAntiForgeryToken]
        [AjaxOnly]
        public ActionResult SaveForm(string keyValue,string strEntity)
        {
            ec_business_tableEntity entity = strEntity.ToObject<ec_business_tableEntity>();
            //新建、编辑业务表时，业务表名称、业务表编号不允许重复。
            var data = ec_business_tableIBLL.GetList("{}").ToList();
            data = data.FindAll(x => x.BusinessTableName == entity.BusinessTableName || x.BusinessTableCode == entity.BusinessTableCode);
            if (data != null && data.Count > 0)
            {
                if (!string.IsNullOrEmpty(keyValue))
                {
                    data = data.FindAll(x => x.BusinessTableID != keyValue);
                    if (data != null && data.Count > 0)
                    {
                        return Fail("业务表名称或业务表编号重复！");
                    }
                }
                else
                {
                    return Fail("业务表名称或业务表编号重复！");
                }
            }
            ec_business_tableIBLL.SaveEntity(keyValue, entity);
            return Success("保存成功！", "业务表管理", string.IsNullOrEmpty(keyValue) ? OperationType.Create : OperationType.Update, null, null);
        }
        #endregion

    }
}
